/************************************************************************************
hazardmeshirs
Copyright (c) 2010, International Rescue System Institute
All rights reserved.

Contact us if you use this software for sell.
If you use this software not for sell, you can use this software under BSD license.
See the files LICENSE.TXT and LICENSE-BSD.TXT for more details.                     
************************************************************************************/

//***************************************************************************************//
//* TestOutput.cpp							     2010.02.06 *//
//*											*//
//* Test Output RTMプログラム [Ver.0.1.0]						*//
//***************************************************************************************//


// -*- C++ -*-
/*!
 * @file  TestOutput.cpp
 * @brief Test Output for Management of Area Map Module
 * $Date$
 *
 * $Id$
 */

#include "TestOutput.h"

// Module specification
// <rtc-template block="module_spec">
static const char* testoutput_spec[] =
  {
    "implementation_id", "TestOutput",
    "type_name",         "TestOutput",
    "description",       "Test Output for Hazard Mesh Module",
    "version",           "1.0.0",
    "vendor",            "IRS",
    "category",          "Map",
    "activity_type",     "DataFlowComponent",
    "max_instance",      "1",
    "language",          "C++",
    "lang_type",         "compile",
    // Configuration variables

    ""
  };
// </rtc-template>

TestOutput::TestOutput(RTC::Manager* manager)
  : RTC::DataFlowComponentBase(manager),
    // <rtc-template block="initializer">
    m_MeshDataIn("MeshData", m_MeshData),
    
    // </rtc-template>
	dummy(0)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  registerInPort("MeshData", m_MeshDataIn);
  
  // Set OutPort buffer
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

}

TestOutput::~TestOutput()
{
}


RTC::ReturnCode_t TestOutput::onInitialize()
{
	// <rtc-template block="bind_config">
  // Bind variables and configuration variable
  
	// </rtc-template>

	return RTC::RTC_OK;										// 戻り値 [正常終了]

}



/*
RTC::ReturnCode_t TestOutput::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TestOutput::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TestOutput::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

RTC::ReturnCode_t TestOutput::onActivated(RTC::UniqueId ec_id)
{

	return RTC::RTC_OK;										// 戻り値 [正常終了]

}

RTC::ReturnCode_t TestOutput::onDeactivated(RTC::UniqueId ec_id)
{

	return RTC::RTC_OK;										// 戻り値 [正常終了]

}

RTC::ReturnCode_t TestOutput::onExecute(RTC::UniqueId ec_id)
{


	//-- [データ更新] -----------------------------------------------------------------------//

	if(m_MeshDataIn.isNew()){									// 更新チェック

		m_MeshDataIn.read();									// データ読み込み


		//-- [タイムスタンプ表示] -------------------------------------------------------//

		printf("\n[Timestamp   ] %lf\n",
			(double)m_MeshData.tm.sec + (double)m_MeshData.tm.nsec / 1000000000.0);		// メッセージ表示 [Timestamp]

		//-------------------------------------------------------------------------------//


		//-- [モード表示] ---------------------------------------------------------------//

		printf("[Mode        ] %5d -> %d%d%d%d%d%d%d%d%d%d%d%d%d%d%d%d\n", m_MeshData.mode,
			(m_MeshData.mode & 0x8000) >> 15, (m_MeshData.mode & 0x4000) >> 14,
			(m_MeshData.mode & 0x2000) >> 13, (m_MeshData.mode & 0x1000) >> 12,
			(m_MeshData.mode & 0x0800) >> 11, (m_MeshData.mode & 0x0400) >> 10,
			(m_MeshData.mode & 0x0200) >>  9, (m_MeshData.mode & 0x0100) >>  8,
			(m_MeshData.mode & 0x0080) >>  7, (m_MeshData.mode & 0x0040) >>  6,
			(m_MeshData.mode & 0x0020) >>  5, (m_MeshData.mode & 0x0010) >>  4,
			(m_MeshData.mode & 0x0008) >>  3, (m_MeshData.mode & 0x0004) >>  2,
			(m_MeshData.mode & 0x0002) >>  1, (m_MeshData.mode & 0x0001));			// メッセージ表示 [mode]

		//-------------------------------------------------------------------------------//


		//-- [地域名表示] ---------------------------------------------------------------//

		printf("[Location    ] ");								// メッセージ表示 [location]

		for(i = 0; i < DATASIZE; i++){

			printf("%c", m_MeshData.location[i]);						// データ表示 [location]
			if(m_MeshData.location[i] == 0x00) break;					// 終端文字チェック

		}

		printf("\n");										// 改行

		//-------------------------------------------------------------------------------//


		//-- [利用者マップセット表示] ---------------------------------------------------//

		printf("[Mapset      ] ");								// メッセージ表示 [mapset]

		for(i = 0; i < DATASIZE; i++){

			printf("%c", m_MeshData.mapset[i]);						// データ表示 [mapset]
			if(m_MeshData.mapset[i] == 0x00) break;						// 終端文字チェック

		}

		printf("\n");										// 改行

		//-------------------------------------------------------------------------------//


		//-- [データタイプ表示] ---------------------------------------------------------//

		printf("[Type        ] ");								// メッセージ表示 [type]

		for(i = 0; i < DATASIZE; i++){

			printf("%c", m_MeshData.type[i]);						// データ表示 [type]
			if(m_MeshData.type[i] == 0x00) break;						// 終端文字チェック

		}

		printf("\n");										// 改行

		//-------------------------------------------------------------------------------//


		//-- [対象原点x座標表示] --------------------------------------------------------//

		printf("[Origin_x    ] %ld\n", m_MeshData.origin_x);					// メッセージ表示 [origin_x]

		//-------------------------------------------------------------------------------//


		//-- [対象原点y座標表示] --------------------------------------------------------//

		printf("[Origin_y    ] %ld\n", m_MeshData.origin_y);					// メッセージ表示 [origin_y]

		//-------------------------------------------------------------------------------//


		//-- [対象範囲x座標表示] --------------------------------------------------------//

		printf("[Size_x      ] %ld\n", m_MeshData.size_x);					// メッセージ表示 [size_x]

		//-------------------------------------------------------------------------------//


		//-- [対象範囲y座標表示] --------------------------------------------------------//

		printf("[Size_y      ] %ld\n", m_MeshData.size_y);					// メッセージ表示 [size_y]

		//-------------------------------------------------------------------------------//


		//-- [地図説明表示] -------------------------------------------------------------//

		printf("[Explanation ] ");								// メッセージ表示 [explanation]

		for(i = 0; i < DATASIZE; i++){

			printf("%c", m_MeshData.explanation[i]);					// データ表示 [explanation]
			if(m_MeshData.explanation[i] == 0x00) break;					// 終端文字チェック

		}

		printf("\n");										// 改行

		//-------------------------------------------------------------------------------//


		//-- [地図原点x座標表示] --------------------------------------------------------//

		printf("[Map_origin_x] %ld\n", m_MeshData.map_origin_x);				// メッセージ表示 [map_origin_x]

		//-------------------------------------------------------------------------------//


		//-- [地図原点y座標表示] --------------------------------------------------------//

		printf("[Map_origin_y] %ld\n", m_MeshData.map_origin_y);				// メッセージ表示 [map_origin_y]

		//-------------------------------------------------------------------------------//


		//-- [地図サイズx座標表示] ------------------------------------------------------//

		printf("[Map_size_x  ] %ld\n", m_MeshData.map_size_x);					// メッセージ表示 [map_size_x]

		//-------------------------------------------------------------------------------//


		//-- [地図サイズy座標表示] ------------------------------------------------------//

		printf("[Map_size_y  ] %ld\n", m_MeshData.map_size_y);					// メッセージ表示 [map_size_y]

		//-------------------------------------------------------------------------------//


		//-- [ピクセルサイズx座標表示] --------------------------------------------------//

		printf("[Pixel_size_x] %ld\n", m_MeshData.pixel_size_x);				// メッセージ表示 [pixel_size_x]

		//-------------------------------------------------------------------------------//


		//-- [ピクセルサイズy座標表示] --------------------------------------------------//

		printf("[Pixel_size_y] %ld\n", m_MeshData.pixel_size_y);				// メッセージ表示 [pixel_size_y]

		//-------------------------------------------------------------------------------//


		//-- [カテゴリデータ表示] -------------------------------------------------------//

		printf("[Category    ] ");								// メッセージ表示 [category]

		for(i = 0; i < DATASIZE; i++){

			printf("%c", m_MeshData.category[i]);						// データ表示 [category]
			if(m_MeshData.category[i] == 0x00) break;					// 終端文字チェック

		}

		printf("\n");										// 改行

		//-------------------------------------------------------------------------------//


		//-- [地図データ表示] -----------------------------------------------------------//

		printf("[Mapdata     ]\n");								// メッセージ表示 [mapdata]

		for(i = 0; i < (int)((m_MeshData.size_x / m_MeshData.pixel_size_x)
			* (m_MeshData.size_y / m_MeshData.pixel_size_y)); i++){

			printf("%ld", m_MeshData.mapdata[i]);						// データ表示 [mapdata]

			if(((i + 1) % (m_MeshData.size_x / m_MeshData.pixel_size_x)) == 0)
				printf("\n");								// 改行

		}

		printf("\n");										// 改行

		//-------------------------------------------------------------------------------//


		//-- [復帰処理] -----------------------------------------------------------------//

		fflush(stdout);										// バッファフラッシュ [printf表示用]

		//-------------------------------------------------------------------------------//


	}

	//---------------------------------------------------------------------------------------//


	return RTC::RTC_OK;										// 戻り値 [正常終了]

}

/*
RTC::ReturnCode_t TestOutput::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TestOutput::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TestOutput::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TestOutput::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TestOutput::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{

  void TestOutputInit(RTC::Manager* manager)
  {
    RTC::Properties profile(testoutput_spec);
    manager->registerFactory(profile,
                             RTC::Create<TestOutput>,
                             RTC::Delete<TestOutput>);
  }

};


